diff -crN nakedmudv1.4/src/mud.h nakedmudv1.5/src/mud.h
*** nakedmudv1.4/src/mud.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/mud.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 27,42 ****
  #define MODULE_ALIAS
  #define MODULE_CHAR_VARS
  #define MODULE_SOCIALS
! 
! 
! //
! // Two modules that I am working on... together, they work similar to KaVir's
! // Gladiator Pits. Expect to see them for download in the near future.
! //   - Geoff Hollis, Dec26/04
! //
! //#define MODULE_FACULTY
! //#define MODULE_COMBAT
! //
  
  
  
--- 27,33 ----
  #define MODULE_ALIAS
  #define MODULE_CHAR_VARS
  #define MODULE_SOCIALS
! #define MODULE_HELP
  
  
  
***************
*** 49,55 ****
  //*****************************************************************************
  typedef struct socket_data                SOCKET_DATA;
  typedef struct char_data                  CHAR_DATA;  
- typedef struct help_data                  HELP_DATA;
  typedef struct lookup_data                LOOKUP_DATA;
  typedef struct list                       LIST;
  typedef struct list_iterator              LIST_ITERATOR;
--- 40,45 ----
***************
*** 57,62 ****
--- 47,54 ----
  typedef struct hashtable_iterator         HASH_ITERATOR;
  typedef struct hashmap                    HASHMAP;
  typedef struct map_iterator               MAP_ITERATOR;
+ typedef struct set_data                   SET;
+ typedef struct set_iterator               SET_ITERATOR;
  typedef struct datatable                  DATATABLE;
  typedef struct storage_set                STORAGE_SET;
  typedef struct storage_set_list           STORAGE_SET_LIST;
***************
*** 108,113 ****
--- 100,106 ----
  #include "list.h"
  #include "hashmap.h"
  #include "hashtable.h"
+ #include "set.h"
  
  
  
***************
*** 136,142 ****
  #define MAX_INPUT_LEN       512                   /* max length of a string someone can input */
  #define SMALL_BUFFER       1024
  #define MAX_BUFFER         8192                   /* seems like a decent amount         */
- #define MAX_HELP_ENTRY     (MAX_BUFFER)
  #define MAX_SCRIPT         16384                  /* max length of a script */
  #define MAX_OUTPUT         8192                   /* well shoot me if it isn't enough   */
  #define FILE_TERMINATOR    "EOF"                  /* end of file marker                 */
--- 129,134 ----
***************
*** 183,192 ****
  #define COMM_LOG              10  /* admins only                     */
  
  
- /* cmd_tog_prf */
- #define SUBCMD_BUILDWALK       0
- 
- 
  #define NOWHERE        (-1)
  #define NOTHING        (-1)
  #define NOBODY         (-1)
--- 175,180 ----
***************
*** 211,224 ****
   ******************************/
  
  /* the actual structures */
- struct help_data
- {
-   HELP_DATA     * next;
-   time_t          load_time;
-   char          * keyword;
-   char          * text;
- };
- 
  struct lookup_data
  {
    SOCKET_DATA       * dsock;   /* the socket we wish to do a hostlookup on */
--- 199,204 ----
***************
*** 264,275 ****
  extern  LIST           *mobile_list;
  extern  PROPERTY_TABLE *mob_table;      /* same contents as mobile_list, but
  					   arranged by uid (unique ID)        */
- extern  HELP_DATA   *   help_list;      /* the linked list of help files      */
  extern  const struct    typCmd tabCmd[];/* the command table                  */
  extern  bool            shut_down;      /* used for shutdown                  */
  extern  int             mudport;        /* What port are we running on?       */
  extern  char        *   greeting;       /* the welcome greeting               */
! extern  char        *   motd;           /* the MOTD help file                 */
  extern  int             control;        /* boot control socket thingy         */
  extern  time_t          current_time;   /* let's cut down on calls to time()  */
  
--- 244,254 ----
  extern  LIST           *mobile_list;
  extern  PROPERTY_TABLE *mob_table;      /* same contents as mobile_list, but
  					   arranged by uid (unique ID)        */
  extern  const struct    typCmd tabCmd[];/* the command table                  */
  extern  bool            shut_down;      /* used for shutdown                  */
  extern  int             mudport;        /* What port are we running on?       */
  extern  char        *   greeting;       /* the welcome greeting               */
! extern  char        *   motd;           /* the MOTD message                   */
  extern  int             control;        /* boot control socket thingy         */
  extern  time_t          current_time;   /* let's cut down on calls to time()  */
  
***************
*** 322,330 ****
  /* io.c */
  void    log_string            ( const char *txt, ... ) __attribute__ ((format (printf, 1, 2)));
  void    bug                   ( const char *txt, ... ) __attribute__ ((format (printf, 1, 2)));
- time_t  last_modified         ( char *helpfile );
  char   *read_file             ( const char *file );
- char   *read_help_entry       ( const char *helpfile);
  char   *fread_line            ( FILE *fp );                 /* pointer        */
  char   *fread_string          ( FILE *fp );                 /* allocated data */
  char   *fread_word            ( FILE *fp );                 /* pointer        */
--- 301,307 ----
***************
*** 361,368 ****
  void  page_continue         ( SOCKET_DATA *dsock);
  void  page_back             ( SOCKET_DATA *dsock);
  
- /* help.c */
- bool check_help(CHAR_DATA *dMob, char *helpfile);
  
  /*******************************
   * End of prototype declartion *
--- 338,343 ----
diff -crN nakedmudv1.4/src/object.c nakedmudv1.5/src/object.c
*** nakedmudv1.4/src/object.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/object.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 148,173 ****
  
  STORAGE_SET *objStore(OBJ_DATA *obj) {
    STORAGE_SET *set = new_storage_set();
!   store_int   (set, "vnum",      obj->vnum,                 NULL);
!   store_int   (set, "type",      obj->type,                 NULL);
!   store_int   (set, "subtype",   obj->subtype,              NULL);
!   store_int   (set, "value 0",   objGetVal(obj, 0),         NULL);
!   store_int   (set, "value 1",   objGetVal(obj, 1),         NULL);
!   store_int   (set, "value 2",   objGetVal(obj, 2),         NULL);
!   store_int   (set, "value 3",   objGetVal(obj, 3),         NULL);
!   store_int   (set, "value 4",   objGetVal(obj, 4),         NULL);
!   store_double(set, "weight",    obj->weight,               NULL);
!   store_double(set, "capacity",  obj->capacity,             NULL);
!   store_string(set, "name",      obj->name,                 NULL);
!   store_string(set, "keywords",  obj->keywords,             NULL);
!   store_string(set, "rdesc",     obj->rdesc,                NULL);
!   store_string(set, "desc",      obj->desc,                 NULL);
!   store_string(set, "multiname", obj->multi_name,           NULL);
!   store_string(set, "multirdesc",obj->multi_rdesc,          NULL);
!   store_string(set, "bits",      write_bits(obj->bits),     NULL);
!   store_set   (set, "edescs",    edescSetStore(obj->edescs),NULL);
!   store_set   (set, "auxiliary", auxiliaryDataStore(obj->auxiliary_data), NULL);
!   store_list  (set, "contents",  gen_store_list(obj->contents, objStore), NULL);
    return set;
  }
  
--- 148,173 ----
  
  STORAGE_SET *objStore(OBJ_DATA *obj) {
    STORAGE_SET *set = new_storage_set();
!   store_int   (set, "vnum",      obj->vnum);
!   store_int   (set, "type",      obj->type);
!   store_int   (set, "subtype",   obj->subtype);
!   store_int   (set, "value 0",   objGetVal(obj, 0));
!   store_int   (set, "value 1",   objGetVal(obj, 1));
!   store_int   (set, "value 2",   objGetVal(obj, 2));
!   store_int   (set, "value 3",   objGetVal(obj, 3));
!   store_int   (set, "value 4",   objGetVal(obj, 4));
!   store_double(set, "weight",    obj->weight);
!   store_double(set, "capacity",  obj->capacity);
!   store_string(set, "name",      obj->name);
!   store_string(set, "keywords",  obj->keywords);
!   store_string(set, "rdesc",     obj->rdesc);
!   store_string(set, "desc",      obj->desc);
!   store_string(set, "multiname", obj->multi_name);
!   store_string(set, "multirdesc",obj->multi_rdesc);
!   store_string(set, "bits",      write_bits(obj->bits));
!   store_set   (set, "edescs",    edescSetStore(obj->edescs));
!   store_set   (set, "auxiliary", auxiliaryDataStore(obj->auxiliary_data));
!   store_list  (set, "contents",  gen_store_list(obj->contents, objStore));
    return set;
  }
  
diff -crN nakedmudv1.4/src/olc/medit.c nakedmudv1.5/src/olc/medit.c
*** nakedmudv1.4/src/olc/medit.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/olc/medit.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 43,50 ****
  #ifdef MODULE_SCRIPTS
  		 "{gS) Script menu\r\n"
  #endif
! 		 "{gR) Change race  {y[{c%8s{y]\r\n"
! 		 "{gD) Dialog       {y[{c%8d{y]  {w%s\r\n",
  		 charGetVnum(mob),
  		 charGetName(mob),
  		 charGetMultiName(mob),
--- 43,51 ----
  #ifdef MODULE_SCRIPTS
  		 "{gS) Script menu\r\n"
  #endif
! 		 "{gR) Change race   {y[{c%8s{y]\r\n"
! 		 "{gG) Change Gender {y[{c%8s{y]\r\n"
! 		 "{gD) Dialog        {y[{c%8d{y]  {w%s\r\n",
  		 charGetVnum(mob),
  		 charGetName(mob),
  		 charGetMultiName(mob),
***************
*** 52,58 ****
  		 charGetRdesc(mob),
  		 charGetMultiRdesc(mob),
  		 charGetDesc(mob),
! 		 raceGetName(charGetRace(mob)),
  		 charGetDialog(mob),
  		 (worldGetDialog(gameworld, charGetDialog(mob)) ?
  		  dialogGetName(worldGetDialog(gameworld, 
--- 53,60 ----
  		 charGetRdesc(mob),
  		 charGetMultiRdesc(mob),
  		 charGetDesc(mob),
! 		 charGetRace(mob),
! 		 sexGetName(charGetSex(mob)),
  		 charGetDialog(mob),
  		 (worldGetDialog(gameworld, charGetDialog(mob)) ?
  		  dialogGetName(worldGetDialog(gameworld, 
***************
*** 65,86 ****
  		 );
  }
  
! void medit_race_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
    int i;
!   for(i = 0; i < NUM_RACES; i++)
!     send_to_socket(sock, "%2d) %-20s%s", 
! 		   i, raceGetName(i), (i % 3 == 2 ?"\r\n":""));
!   if(i % 3 != 0)
!     send_to_socket(sock, "\r\n");
!   send_to_socket(sock,
! 		 "\r\nPlease select a race: ");
  }
  
  void medit_main_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
    int next_substate = MEDIT_MAIN;
  
!   switch(*arg) {
!   case 'q':
    case 'Q':
      send_to_socket(sock, "Save changes (Y/N) : ");
      next_substate = MEDIT_CONFIRM_SAVE;
--- 67,87 ----
  		 );
  }
  
! void medit_sex_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
    int i;
!   for(i = 0; i < NUM_SEXES; i++)
!     send_to_socket(sock, "%2d) %s\r\n", i, sexGetName(i));
! }
! 
! void medit_race_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
!   send_to_socket(sock, "%s\r\n\r\n", raceGetList(FALSE));
!   send_to_socket(sock, "Please select a race: ");
  }
  
  void medit_main_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
    int next_substate = MEDIT_MAIN;
  
!   switch(toupper(*arg)) {
    case 'Q':
      send_to_socket(sock, "Save changes (Y/N) : ");
      next_substate = MEDIT_CONFIRM_SAVE;
***************
*** 119,138 ****
      next_substate = MEDIT_MAIN;
      break;
  
-   case 'r':
    case 'R':
      medit_race_menu(sock, olc);
      next_substate = MEDIT_RACE;
      break;
  
!   case 'd':
    case 'D':
      send_to_socket(sock, "Enter new dialog vnum (-1 for none) : ");
      next_substate = MEDIT_DIALOG;
      break;
  
  #ifdef MODULE_SCRIPTS
-   case 's':
    case 'S':
      olcSetNext(olc, newOLC(OLC_SSEDIT, SSEDIT_MAIN,
  			   copyScriptSet(charGetScripts((CHAR_DATA *)olcGetData(olc))), charGetName((CHAR_DATA *)olcGetData(olc))));
--- 120,141 ----
      next_substate = MEDIT_MAIN;
      break;
  
    case 'R':
      medit_race_menu(sock, olc);
      next_substate = MEDIT_RACE;
      break;
  
!   case 'G':
!     medit_sex_menu(sock, olc);
!     next_substate = MEDIT_SEX;
!     break;
! 
    case 'D':
      send_to_socket(sock, "Enter new dialog vnum (-1 for none) : ");
      next_substate = MEDIT_DIALOG;
      break;
  
  #ifdef MODULE_SCRIPTS
    case 'S':
      olcSetNext(olc, newOLC(OLC_SSEDIT, SSEDIT_MAIN,
  			   copyScriptSet(charGetScripts((CHAR_DATA *)olcGetData(olc))), charGetName((CHAR_DATA *)olcGetData(olc))));
***************
*** 208,227 ****
      break;
  
    case MEDIT_RACE: {
!     int race = RACE_NONE;
!     if(isdigit(*arg)) race = atoi(arg);
!     else              race = raceGetNum(arg);
!     if(race == RACE_NONE) {
        send_to_socket(sock, "Invalid race! Try again: ");
        next_substate = MEDIT_RACE;
      }
      else {
!       charSetRace(mob, race);
        charResetBody(mob);
      }
      break;
    }
  
    case MEDIT_DIALOG: {
      int vnum = (*arg ? atoi(arg) : NOTHING);
      DIALOG_DATA *dialog = worldGetDialog(gameworld, vnum);
--- 211,240 ----
      break;
  
    case MEDIT_RACE: {
!     if(!isRace(arg)) {
        send_to_socket(sock, "Invalid race! Try again: ");
        next_substate = MEDIT_RACE;
      }
      else {
!       charSetRace(mob, arg);
        charResetBody(mob);
      }
      break;
    }
  
+   case MEDIT_SEX: {
+     int sex = SEX_NONE;
+     if(isdigit(*arg)) sex = atoi(arg);
+     else              sex = sexGetNum(arg);
+     if(sex == SEX_NONE) {
+       send_to_socket(sock, "Invalid gender! Try again: ");
+       next_substate = MEDIT_SEX;
+     }
+     else
+       charSetSex(mob, sex);
+     break;
+   }
+ 
    case MEDIT_DIALOG: {
      int vnum = (*arg ? atoi(arg) : NOTHING);
      DIALOG_DATA *dialog = worldGetDialog(gameworld, vnum);
diff -crN nakedmudv1.4/src/olc/olc.c nakedmudv1.5/src/olc/olc.c
*** nakedmudv1.4/src/olc/olc.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/olc/olc.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 67,72 ****
--- 67,73 ----
  #endif
  
  
+ 
  struct olc_data {
    bool complete;
    bool save;
***************
*** 100,106 ****
  #endif
  #ifdef MODULE_SOCIALS
    add_cmd("socedit",    NULL, cmd_socedit,  0, POS_SITTING, POS_FLYING,
! 	  LEVEL_PLAYER,  FALSE, TRUE );
  #endif
  }
  
--- 101,107 ----
  #endif
  #ifdef MODULE_SOCIALS
    add_cmd("socedit",    NULL, cmd_socedit,  0, POS_SITTING, POS_FLYING,
! 	  LEVEL_BUILDER,  FALSE, TRUE );
  #endif
  }
  
***************
*** 322,327 ****
--- 323,329 ----
    }
  #endif
  
+ 
    case OLC_RESEDIT:
    case OLC_RESPEDIT:
    case OLC_SSEDIT:
***************
*** 796,802 ****
  
  
  COMMAND(cmd_wedit) {
! 
  }
  
  
--- 798,804 ----
  
  
  COMMAND(cmd_wedit) {
!   send_to_char(ch, "Wedit has not been completed yet.\r\n");
  }
  
  
diff -crN nakedmudv1.4/src/olc/redit.c nakedmudv1.5/src/olc/redit.c
*** nakedmudv1.4/src/olc/redit.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/olc/redit.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 96,102 ****
  
    // now special exits
    int num_spec_exits = 0;
!   char **room_names = roomGetExitNames(room, &num_spec_exits);
    for(i = 0; i < num_spec_exits; i++) {
      EXIT_DATA *exit = roomGetExitSpecial(room, room_names[i]);
      send_to_socket(sock, "   {g%-10s : {y[{c%6d{y]%s",
--- 96,102 ----
  
    // now special exits
    int num_spec_exits = 0;
!   const char **room_names = roomGetExitNames(room, &num_spec_exits);
    for(i = 0; i < num_spec_exits; i++) {
      EXIT_DATA *exit = roomGetExitSpecial(room, room_names[i]);
      send_to_socket(sock, "   {g%-10s : {y[{c%6d{y]%s",
***************
*** 110,117 ****
      send_to_socket(sock, "\r\n");
  
    // clean up our mess
-   for(i = 0; i < num_spec_exits; i++)
-     free(room_names[i]);
    free(room_names);
  }
  
--- 110,115 ----
diff -crN nakedmudv1.4/src/olc/zedit.c nakedmudv1.5/src/olc/zedit.c
*** nakedmudv1.4/src/olc/zedit.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/olc/zedit.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 42,49 ****
  void zedit_main_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
    int next_substate = ZEDIT_MAIN;
  
!   switch(*arg) {
!   case 'q':
    case 'Q':
      send_to_socket(sock, "Save changes (Y/N) : ");
      next_substate = ZEDIT_CONFIRM_SAVE;
--- 42,48 ----
  void zedit_main_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
    int next_substate = ZEDIT_MAIN;
  
!   switch(toupper(*arg)) {
    case 'Q':
      send_to_socket(sock, "Save changes (Y/N) : ");
      next_substate = ZEDIT_CONFIRM_SAVE;
diff -crN nakedmudv1.4/src/property_table.c nakedmudv1.5/src/property_table.c
*** nakedmudv1.4/src/property_table.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/property_table.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 44,49 ****
--- 44,50 ----
  // Find the bucket the key belongs to
  //
  int find_bucket(int key, int num_buckets) {
+   if(key < 0) key *= -1;
    // simple for now: just take the modulo
    return key % num_buckets;
  };
diff -crN nakedmudv1.4/src/races.c nakedmudv1.5/src/races.c
*** nakedmudv1.4/src/races.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/races.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 2,57 ****
  //
  // races.c
  //
! // contains all of the information assocciated with different races.
  //
  //*****************************************************************************
  
  #include "mud.h"
- #include "races.h"
  #include "body.h"
  #include "utils.h"
  
! struct race_data {
!   char *name;
!   char *abbrev;
!   int  bodytype;
!   bool pc_race;
! };
  
- const struct race_data race_info[NUM_RACES] = {
-   { "human", "hum",  BODYTYPE_HUMANOID, TRUE  },
-   { "elf",   "elf",  BODYTYPE_HUMANOID, TRUE  },
-   { "dragon","drg",  BODYTYPE_DRAGON,  FALSE  }
- };
  
- bool raceIsForPC(int race) {
-   return race_info[race].pc_race;
- }
  
! BODY_DATA *raceCreateBody(int race) {
!   return bodyCreate(race_info[race].bodytype);
! }
  
! const char *raceGetName(int race) {
!   return race_info[race].name;
  }
  
- const char *raceGetAbbrev(int race) {
-   return race_info[race].abbrev;
- }
  
- int raceGetNum(const char *race) {
-   int i;
-   for(i = 0; i < NUM_RACES; i++)
-     if(!strcasecmp(race_info[i].name, race))
-       return i;
-   return RACE_NONE;
- }
  
! int raceGetAbbrevNum(const char *race) {
!   int i;
!   for(i = 0; i < NUM_RACES; i++)
!     if(!strcasecmp(race_info[i].abbrev, race))
!       return i;
!   return RACE_NONE;
  }
--- 2,157 ----
  //
  // races.c
  //
! // contains all of the information assocciated with different races. If you are
! // wanting to add new races to the MUD, it is suggested you do so through the
! // add_race() function, and make a new module for your MUD's races.
  //
  //*****************************************************************************
  
  #include "mud.h"
  #include "body.h"
  #include "utils.h"
  
! #include "races.h"
  
  
  
! //*****************************************************************************
! //
! // local datastructures, functions, and defines
! //
! //*****************************************************************************
  
! // how big is hour hashtable for holding race data?
! #define RACE_TABLE_SIZE    10
! HASHTABLE *race_table = NULL;
! 
! 
! typedef struct race_data {
!   char      *name;
!   char      *abbrev;
!   BODY_DATA *body;
!   bool       pc_ok;
! } RACE_DATA;
! 
! 
! RACE_DATA *newRace(const char *name, const char *abbrev, BODY_DATA *body,
! 		   bool pc_ok) {
!   RACE_DATA *data = malloc(sizeof(RACE_DATA));
!   data->name   = strdup(name ? name : "");
!   data->abbrev = strdup(abbrev ? abbrev : "");
!   data->body   = body;
!   data->pc_ok  = pc_ok;
!   return data;
  }
  
  
  
! //*****************************************************************************
! //
! // implementation of race.h
! //
! //*****************************************************************************
! void init_races() {
!   // create the table for holding race data
!   race_table = newHashtable(RACE_TABLE_SIZE);
! 
!   // make the default human body
!   BODY_DATA *body = newBody();
!   bodySetSize(body, BODYSIZE_MEDIUM);
!   bodyAddPosition(body, "right grip",              BODYPOS_HELD,          0);
!   bodyAddPosition(body, "left grip",               BODYPOS_HELD,          0);
!   bodyAddPosition(body, "right foot",              BODYPOS_RIGHT_FOOT,    2);
!   bodyAddPosition(body, "left foot",               BODYPOS_LEFT_FOOT,     2);
!   bodyAddPosition(body, "right leg",               BODYPOS_LEG,           9);
!   bodyAddPosition(body, "left leg",                BODYPOS_LEG,           9);
!   bodyAddPosition(body, "waist",                   BODYPOS_WAIST,         1);
!   bodyAddPosition(body, "right finger",            BODYPOS_FINGER,        1);
!   bodyAddPosition(body, "left finger",             BODYPOS_FINGER,        1);
!   bodyAddPosition(body, "right hand",              BODYPOS_RIGHT_HAND,    2);
!   bodyAddPosition(body, "left hand",               BODYPOS_LEFT_HAND,     2);
!   bodyAddPosition(body, "right wrist",             BODYPOS_WRIST,         1);
!   bodyAddPosition(body, "left wrist",              BODYPOS_WRIST,         1);
!   bodyAddPosition(body, "right arm",               BODYPOS_ARM,           7);
!   bodyAddPosition(body, "left arm",                BODYPOS_ARM,           7);
!   bodyAddPosition(body, "about body",              BODYPOS_ABOUT,         0);
!   bodyAddPosition(body, "torso",                   BODYPOS_TORSO,        50);
!   bodyAddPosition(body, "neck",                    BODYPOS_NECK,          1);
!   bodyAddPosition(body, "right ear",               BODYPOS_EAR,           0);
!   bodyAddPosition(body, "left ear",                BODYPOS_EAR,           0);
!   bodyAddPosition(body, "face",                    BODYPOS_FACE,          2);
!   bodyAddPosition(body, "head",                    BODYPOS_HEAD,          2);
!   bodyAddPosition(body, "floating about head",     BODYPOS_FLOAT,         0);
!   //                                                                  ------
!   //                                                                    100
! 
!   // add the basic races
!   add_race("human", "hum", body, TRUE);
!   //********************************************************************
!   // If you are wanting to add new, non-stock races it is suggested
!   // you do so through a module and import them with add_race instead
!   // of putting them directly into this folder. This will make your life
!   // much easier whenever new versions of NakedMud are released and you
!   // want to upgrade!
!   //********************************************************************
! }
! 
! 
! void add_race(const char *name, const char *abbrev, BODY_DATA *body, int pc_ok){
!   hashPut(race_table, name, newRace(name, abbrev, body, pc_ok));
! }
! 
! int raceCount() {
!   return hashSize(race_table);
! }
! 
! bool isRace(const char *name) {
!   return (hashGet(race_table, name) != NULL);
! }
! 
! BODY_DATA *raceCreateBody(const char *name) {
!   RACE_DATA *data = hashGet(race_table, name);
!   return (data ? bodyCopy(data->body) : NULL);
! }
! 
! bool raceIsForPC(const char *name) {
!   RACE_DATA *data = hashGet(race_table, name);
!   return (data ? data->pc_ok : FALSE);
! }
! 
! const char *raceGetAbbrev(const char *name) {
!   RACE_DATA *data = hashGet(race_table, name);
!   return (data ? data->abbrev : NULL);
! }
! 
! const char *raceDefault() {
!   return "human";
! }
! 
! const char *raceGetList(bool pc_only) {
!   static char buf[MAX_BUFFER];
!   LIST       *name_list = newList();
!   HASH_ITERATOR *race_i = newHashIterator(race_table);
!   const char      *name = NULL;
!   RACE_DATA       *data = NULL;
! 
!   // collect all of our names
!   ITERATE_HASH(name, data, race_i) {
!     if(pc_only && data->pc_ok == FALSE) continue;
!     listPutWith(name_list, strdup(name), strcmp);
!   }
!   deleteHashIterator(race_i);
! 
!   // print all the names to our buffer
!   char *new_name = NULL; // gotta use a new name ptr.. can't free const
!   int i = 0;
!   while( (new_name = listPop(name_list)) != NULL) {
!     i += snprintf(buf+i, MAX_BUFFER-i, "%s%s",
! 		  new_name, (listSize(name_list) > 0 ? ", " : ""));
!     free(new_name);
!   }
! 
!   // delete our list of names and return the buffer
!   deleteListWith(name_list, free);
!   return buf;
  }
diff -crN nakedmudv1.4/src/races.h nakedmudv1.5/src/races.h
*** nakedmudv1.4/src/races.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/races.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 1,29 ****
! #ifndef __RACES_H
! #define __RACES_H
  //*****************************************************************************
  //
  // races.h
  //
! // contains all of the information assocciated with different races.
  //
  //*****************************************************************************
  
  
! #define RACE_NONE           (-1)
! #define RACE_HUMAN            0
! #define RACE_ELF              1
! #define RACE_DRAGON           2
! #define NUM_RACES             3
! 
! //
! // Create a copy of the bodytype assocciated with the race.
! //
! BODY_DATA *raceCreateBody(int race);
! 
! bool raceIsForPC(int race);
! const char *raceGetName(int race);
! const char *raceGetAbbrev(int race);
! int raceGetNum(const char *race);
! int raceGetAbbrevNum(const char *race);
! 
! #endif // __RACES_H
--- 1,23 ----
! #ifndef RACES_H
! #define RACES_H
  //*****************************************************************************
  //
  // races.h
  //
! // contains all of the information assocciated with different races. If you are
! // wanting to add new races to the MUD, it is suggested you do so through the
! // add_race() function, and make a new module for your MUD's races.
  //
  //*****************************************************************************
  
+ void init_races();
+ void add_race(const char *name, const char *abbrev, BODY_DATA *body, int pc_ok);
+ int raceCount();
+ bool isRace(const char *name);
+ BODY_DATA *raceCreateBody(const char *name);
+ bool raceIsForPC(const char *name);
+ const char *raceGetAbbrev(const char *name);
+ const char *raceGetList(bool pc_only);
+ const char *raceDefault(void);
  
! #endif // RACES_H
